<template>
  <div class="role-card">
    <router-link
      class="role-card__content"
      :to="{ name: 'RoleDetails', params: { id: role.id } }"
    >
      <div class="role-card__activity" v-if="!role.active">Inactive</div>
      <div class="role-card__header">
        <h3 class="role-card__name">{{ role.name }}</h3>
        <h4 class="role-card__type">{{ role.type }}</h4>
      </div>
      <div class="role-card__desc">
        {{ truncate(role.description, 120, true) }}
      </div>
      <div class="role-card__avatars">
        <div
          class="role-card__avatar"
          v-for="user in role.users"
          :key="user.id"
        >
          <img :src="user.photo_url" alt="John" />
        </div>
      </div>
    </router-link>

    <div class="role-card__footer">
      <div class="role-card__created">
        Date created: {{ formatDate(role.created_on) }}
      </div>
      <div class="role-card__actions" v-if="role.editable">
        <div class="role-card__action">Edit</div>
        <div class="role-card__action is-red">Delete</div>
      </div>
      <div class="role-card__lock" v-else>
        <span class="icon icon-lock"></span>
      </div>
    </div>
  </div>
</template>

<script>
import moment from "moment";

export default {
  name: "RoleCard",
  props: {
    role: {
      type: Object,
      required: true,
    },
  },
  methods: {
    formatDate: function (date) {
      return moment(date).format("DD/MM/YYYY");
    },
    truncate(str, n, useWordBoundary) {
      if (str.length <= n) {
        return str;
      }
      const subString = str.substr(0, n - 1);
      return (
        (useWordBoundary
          ? subString.substr(0, subString.lastIndexOf(" "))
          : subString) + "..."
      );
    },
  },
};
</script>
